﻿using System.Web.Mvc;

using System.Collections.Generic;
using System.IO;
namespace FilterDemo.Controllers
{
    public class OrderTestAttribute : FilterAttribute, IResultFilter
    {
        private string name;
        public OrderTestAttribute(string name)
        {
            this.name = name;
        }
        private static void ConstructDic(ControllerContext filterContext,string name)
        {
            var controller = filterContext.Controller;
            Dictionary<int, string> dictionary;
            if (controller.ViewData["dictionary"] != null)
            {
                dictionary = (Dictionary<int, string>)controller.ViewData["dictionary"];
                dictionary.Add(dictionary.Count + 1, name);
            }
            else
            {
                dictionary = new Dictionary<int, string>();
                dictionary.Add(1, name);
                controller.ViewData["dictionary"] = dictionary;
            }
        }
        #region IResultFilter 成员

        void IResultFilter.OnResultExecuted(ResultExecutedContext filterContext)
        {
            ConstructDic(filterContext, "OnResultExecuted" + name);
        }

        void IResultFilter.OnResultExecuting(ResultExecutingContext filterContext)
        {
            ConstructDic(filterContext, "OnResultExecuting" + name);
        }

        #endregion
    }
}