﻿using System.Diagnostics;
using System.Web.Mvc;
public class TimerAttribute : ActionFilterAttribute
{
    public TimerAttribute()
    {
        //By default, we should be the last filter to run
        //so we run just before and after the action method.
        this.Order = int.MaxValue;
    }
    public override void OnActionExecuting(ActionExecutingContext filterContext)
    {
        var controller = filterContext.Controller;
        if (controller != null)
        {
            var stopwatch = new Stopwatch();
            controller.ViewData["__StopWatch"] = stopwatch;
            stopwatch.Start();
        }
    }
    public override void OnActionExecuted(ActionExecutedContext filterContext)
    {
        var controller = filterContext.Controller;
        if (controller != null)
        {
            var stopwatch = (Stopwatch)controller.ViewData["__StopWatch"];
            stopwatch.Stop();
            controller.ViewData["__Duration"] = stopwatch.Elapsed.TotalMilliseconds;
        }
    }
}